package plist

import (
	"testing"

	"github.com/Pallinder/go-randomdata"

	"github.com/emirpasic/gods/utils"
)

func TestPriority(t *testing.T) {
	pl := New(utils.IntComparator)
	for i := 0; i < 20; i++ {
		pl.Insert(randomdata.Number(0, 100000))
	}
	t.Error(pl.String(), pl.Get(5), pl.Get(-1), pl.Get(-pl.size), pl.Get(-pl.size-1))

	iter := pl.Iterator()

	for iter.Next() {
		t.Error(iter.Value())
	}

	for iter.Prev() {
		t.Error(iter.Value())
	}

	for i := 0; i < 20; i++ {
		pl.Remove(0)
		t.Error(pl.String())
	}

}

func BenchmarkPriority(b *testing.B) {
	pl := New(utils.IntComparator)

	b.N = 10000
	for i := 0; i < b.N; i++ {
		pl.Insert(randomdata.Number(0, 100000))
	}
}
